VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "USB Complete"
   ClientHeight    =   4296
   ClientLeft      =   252
   ClientTop       =   336
   ClientWidth     =   6132
   LinkTopic       =   "Form1"
   ScaleHeight     =   4296
   ScaleWidth      =   6132
   Begin VB.ListBox lstResults 
      Height          =   2160
      Left            =   120
      TabIndex        =   9
      Top             =   2040
      Width           =   5892
   End
   Begin VB.CommandButton cmdRequestReports 
      Caption         =   "Request Reports"
      Height          =   372
      Left            =   2400
      TabIndex        =   8
      Top             =   1560
      Width           =   3612
   End
   Begin VB.Frame fraSendReport 
      Caption         =   "Send Report"
      Height          =   1332
      Left            =   3960
      TabIndex        =   5
      Top             =   120
      Width           =   2052
      Begin VB.CommandButton cmdOnce 
         Caption         =   "Once"
         Height          =   372
         Left            =   240
         TabIndex        =   7
         Top             =   240
         Width           =   1452
      End
      Begin VB.CommandButton cmdContinuous 
         Caption         =   "Continuous"
         Height          =   372
         Left            =   240
         TabIndex        =   6
         Top             =   720
         Width           =   1452
      End
   End
   Begin VB.Frame fraBytesReceived 
      Caption         =   "Bytes Received"
      Height          =   1332
      Left            =   2400
      TabIndex        =   3
      Top             =   120
      Width           =   1452
      Begin VB.TextBox txtBytesReceived 
         Height          =   972
         Left            =   120
         MultiLine       =   -1  'True
         TabIndex        =   4
         Top             =   240
         Width           =   1212
      End
   End
   Begin VB.Frame fraBytesToSend 
      Caption         =   "Byte to Send"
      Height          =   1812
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2172
      Begin VB.ComboBox cboByte1 
         Height          =   288
         Left            =   360
         Style           =   2  'Dropdown List
         TabIndex        =   2
         Top             =   600
         Width           =   1212
      End
      Begin VB.CheckBox chkAutoincrement 
         Caption         =   "Autoincrement value"
         Height          =   372
         Left            =   240
         TabIndex        =   1
         Top             =   1200
         Width           =   2412
      End
   End
   Begin VB.Timer tmrContinuousDataCollect 
      Left            =   120
      Top             =   3960
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Project: HIDDemo2.vbp
'Version: 1.1
'Date: 3/8/00
'Copyright 1999 and 2000 by Jan Axelson (jan@lvr.com)

'Purpose:
'Demonstrates communications with an HID-class USB device, using background Read operations.

'Theory of operation:
'The application searches for a device with a particular Vendor and Product ID.
'If successful, the user can request the application to send Output reports to the device
'and receive Input reports from the device.

'The application uses an ActiveX Exe server to read reports from the device.
'The server runs in its own thread, so the application isn't blocked while the server
'waits for the device to send a report.

'Byte 0 in the reports is a signaling byte. When the device receives an Output report, it
'sets byte 0 of its Input reports to match byte 0 in the received Output report.
'Byte 1 in the reports is undefined (and available for any use).
'The device doesn't use Byte 0 in an Output report other than to pass it along to the
'server in its next Input report.
'Byte 0 in an Input report tells the server whether or not to continue attempting to
'read reports from the device.

'The user requests to receive reports from the device by clicking the Request Reports button.
'This causes the application to send an Output report with byte 0 = 0.
'To request the server to begin reading reports from the device, the application
'calls the InitiateHIDReads routine in the server, passing it the application's process ID
'and device ID, a report buffer, and the report length.
'The server then begins reading reports from the device.
'When the server has read a report, it notifies the application by raising its
'ReportReady event.
'The application then retrieves the report by calling the ReturnReportData routine
'in the server with a callback to the ReportData routine.
'The callback passes the report buffer to the application, which displays the report data.

'Clicking the Stop Requesting Reports button causes the server to stop attempting to read
'Input reports from the device. The application sends an Output report with byte 0 = FFh.
'This causes the device to set byte 0 of its next Input report to FFh. When the server
'reads an Input report with byte 0 = FFh, it stops attempting to read reports from
'the device. This enables the server to close. (Otherwise it might hang while waiting
'for the device to send a report.)

'(If the device is removed from the bus while the server is waiting to receive a report,
'the ReadFile will never complete and the thread won't be able to close (except by
'pressing Ctrl-Alt-Delete to close it via the Task Manager) The only way I can think of to
'prevent this (as much as possible) is to send an Output report before every Input request,
'to verify that the device is still attached.)

'The user can also send Output reports to the device using the Once and Continuous buttons.

'The firmware that accompanies this application prepares an Input report once every
'5 seconds, with byte 0 = byte 0 in the last Output report and byte 1 = (byte 1 in
' the last Output report + 1). In between reports, the device returns NAK to IN requests.

'A list box displays the data sent and received in reports,
'along with error and status messages.
'A combo box enables the user to select a byte to send.
'Command buttons enable starting and stopping reading from the device
'and selecting 1-time or continuous sending of Output reports.

'The companion device firmware is hid5sec.asm,
'for Cypress Semiconductor's CY7C63001 USB Microcontroller.
'For more information, visit Lakeview Research at http://www.lvr.com .

'I'm interested in receiving comments, bug reports, suggesetions, etc.
'Send to jan@lvr.com .

'Changes and updates:
'3/8/00
'In RequestReportsFromTheHID, the parameters in Call HIDObj.InitiateHIDReads
'are changed to match the changes in the ActiveX Exe server.
'Stripped two trailing nulls from the device pathname.

Dim Capabilities As HIDP_CAPS
Dim DataString As String
Dim DetailData As Long
Dim DetailDataBuffer() As Byte
Dim DeviceAttributes As HIDD_ATTRIBUTES
Dim DeviceDetected As Boolean
Dim DevicePathName As String
Dim DeviceInfoSet As Long
Dim ErrorString As String
Dim HID As Long
Dim LastDevice As Boolean
Dim MyDeviceDetected As Boolean
Dim MyDeviceInfoData As SP_DEVINFO_DATA
Dim MyDeviceInterfaceDetailData As SP_DEVICE_INTERFACE_DETAIL_DATA
Dim MyDeviceInterfaceData As SP_DEVICE_INTERFACE_DATA
Dim Needed As Long
Dim OutputReportData(7) As Byte
Dim PreparsedData As Long
Dim ReadBuffer() As Byte
Dim ReportNumber As Integer
Dim Result As Long
Dim SendBuffer() As Byte
Dim Timeout As Boolean
Dim WithEvents HIDObj As clsHID
Attribute HIDObj.VB_VarHelpID = -1

'Set these to match the values in the device's firmware and INF file.
Const MyVendorID = &H925
Const MyProductID = &H1234

Private Function DoAWriteFile() As Boolean
'Attempts a WriteFile call. Fails if the device isn't attached.

Dim Count As Integer
Dim NumberOfBytesRead As Long
Dim NumberOfBytesToSend As Long
Dim NumberOfBytesWritten As Long
    
'The SendBuffer array begins at 0, so subtract 1 from the number of bytes.
If Capabilities.OutputReportByteLength > 0 Then
    ReDim SendBuffer(Capabilities.OutputReportByteLength - 1)
Else
    ReDim SendBuffer(0)
End If

'******************************************************************************
'WriteFile
'Sends a report to the device.
'Returns: success or failure.
'Requires: the handle returned by CreateFile and
'The output report byte length returned by HidP_GetCaps
'******************************************************************************

'The first byte is the Report ID
SendBuffer(0) = 0

'The next bytes are data
For Count = 1 To Capabilities.OutputReportByteLength - 1
    SendBuffer(Count) = OutputReportData(Count - 1)
Next Count

NumberOfBytesWritten = 0

Result = WriteFile _
    (HID, _
    SendBuffer(0), _
    CLng(Capabilities.OutputReportByteLength), _
    NumberOfBytesWritten, _
    0)
Call DisplayResultOfAPICall("WriteFile")

lstResults.AddItem " OutputReportByteLength = " & Capabilities.OutputReportByteLength
lstResults.AddItem " NumberOfBytesWritten = " & NumberOfBytesWritten
lstResults.AddItem " Report ID: " & SendBuffer(0)
lstResults.AddItem " Output Report Data:"

If Result = 0 Then
    DoAWriteFile = False
Else
    DoAWriteFile = True
End If

For Count = 1 To UBound(SendBuffer)
    lstResults.AddItem " " & Hex$(SendBuffer(Count))
Next Count
'Scroll to the bottom of the list box.
lstResults.ListIndex = lstResults.ListCount - 1
End Function

Private Function FindTheHid() As Boolean
'Makes a series of API calls to locate the desired HID-class device.
'Returns True if the device is detected, False if not detected.

Dim Count As Integer
Dim GUIDString As String
Dim HidGuid As GUID
Dim MemberIndex As Long

LastDevice = False
MyDeviceDetected = False

'******************************************************************************
'HidD_GetHidGuid
'Get the GUID for all system HIDs.
'Returns: the GUID in HidGuid.
'The routine doesn't return a value in Result
'but the routine is declared as a function for consistency with the other API calls.
'******************************************************************************

Result = HidD_GetHidGuid(HidGuid)
Call DisplayResultOfAPICall("GetHidGuid")

'Display the GUID.
GUIDString = _
    Hex$(HidGuid.Data1) & "-" & _
    Hex$(HidGuid.Data2) & "-" & _
    Hex$(HidGuid.Data3) & "-"

For Count = 0 To 7
    'Ensure that each of the 8 bytes in the GUID displays two characters.
    If HidGuid.Data4(Count) >= &H10 Then
        GUIDString = GUIDString & Hex$(HidGuid.Data4(Count)) & " "
    Else
        GUIDString = GUIDString & "0" & Hex$(HidGuid.Data4(Count)) & " "
    End If
Next Count

lstResults.AddItem "  GUID for system HIDs: " & GUIDString

'******************************************************************************
'SetupDiGetClassDevs
'Returns: a handle to a device information set for all installed devices.
'Requires: the HidGuid returned in GetHidGuid.
'******************************************************************************

DeviceInfoSet = SetupDiGetClassDevs _
    (HidGuid, _
    vbNullString, _
    0, _
    (DIGCF_PRESENT Or DIGCF_DEVICEINTERFACE))
    
Call DisplayResultOfAPICall("SetupDiClassDevs")
DataString = GetDataString(DeviceInfoSet, 32)

'******************************************************************************
'SetupDiEnumDeviceInterfaces
'On return, MyDeviceInterfaceData contains the handle to a
'SP_DEVICE_INTERFACE_DATA structure for a detected device.
'Requires:
'the DeviceInfoSet returned in SetupDiGetClassDevs.
'the HidGuid returned in GetHidGuid.
'An index to specify a device.
'******************************************************************************

'Begin with 0 and increment until no more devices are detected.
MemberIndex = 0

Do
    'The cbSize element of the MyDeviceInterfaceData structure must be set to
    'the structure's size in bytes. The size is 28 bytes.
    MyDeviceInterfaceData.cbSize = LenB(MyDeviceInterfaceData)
    Result = SetupDiEnumDeviceInterfaces _
        (DeviceInfoSet, _
        0, _
        HidGuid, _
        MemberIndex, _
        MyDeviceInterfaceData)
    
    Call DisplayResultOfAPICall("SetupDiEnumDeviceInterfaces")
    If Result = 0 Then LastDevice = True
    
    'If a device exists, display the information returned.
    If Result <> 0 Then
        lstResults.AddItem "  DeviceInfoSet for device #" & CStr(MemberIndex) & ": "
        lstResults.AddItem "  cbSize = " & CStr(MyDeviceInterfaceData.cbSize)
        lstResults.AddItem _
            "  InterfaceClassGuid.Data1 = " & Hex$(MyDeviceInterfaceData.InterfaceClassGuid.Data1)
        lstResults.AddItem _
            "  InterfaceClassGuid.Data2 = " & Hex$(MyDeviceInterfaceData.InterfaceClassGuid.Data2)
        lstResults.AddItem _
            "  InterfaceClassGuid.Data3 = " & Hex$(MyDeviceInterfaceData.InterfaceClassGuid.Data3)
        lstResults.AddItem _
            "  Flags = " & Hex$(MyDeviceInterfaceData.Flags)
    
        
        '******************************************************************************
        'SetupDiGetDeviceInterfaceDetail
        'Returns: an SP_DEVICE_INTERFACE_DETAIL_DATA structure
        'containing information about a device.
        'To retrieve the information, call this function twice.
        'The first time returns the size of the structure in Needed.
        'The second time returns a pointer to the data in DeviceInfoSet.
        'Requires:
        'A DeviceInfoSet returned by SetupDiGetClassDevs and
        'an SP_DEVICE_INTERFACE_DATA structure returned by SetupDiEnumDeviceInterfaces.
        '*******************************************************************************
        
        'The final parameter passed in SetupDIGetDeviceInterfaceDetail
        'is an optional pointer to an SP_DEVINFO_DATA structure.
        'If retrieving the structure, set the size of MyDeviceInfoData:
        'MyDeviceInfoData.cbSize = Len(MyDeviceInfoData)
        'and pass the structure's address (declare the parameter ByRef)
        'This application doesn't retrieve or use the structure.
                
        MyDeviceInfoData.cbSize = Len(MyDeviceInfoData)
        Result = SetupDiGetDeviceInterfaceDetail _
           (DeviceInfoSet, _
           MyDeviceInterfaceData, _
           0, _
           0, _
           Needed, _
           0)
        
        DetailData = Needed
            
        Call DisplayResultOfAPICall("SetupDiGetDeviceInterfaceDetail")
        lstResults.AddItem "  (OK to say too small)"
        lstResults.AddItem "  Required buffer size for the data: " & Needed
        
        'Store the structure's size.
        MyDeviceInterfaceDetailData.cbSize = _
            Len(MyDeviceInterfaceDetailData)
        
        'Use a byte array to allocate memory for
        'the MyDeviceInterfaceDetailData structure
        ReDim DetailDataBuffer(Needed)
        'Store cbSize in the first four bytes of the array.
        Call RtlMoveMemory _
            (DetailDataBuffer(0), _
            MyDeviceInterfaceDetailData, _
            4)
        
        'Call SetupDiGetDeviceInterfaceDetail again.
        'This time, pass the address of the first element of DetailDataBuffer
        'and the returned required buffer size in DetailData.
        Result = SetupDiGetDeviceInterfaceDetail _
           (DeviceInfoSet, _
           MyDeviceInterfaceData, _
           VarPtr(DetailDataBuffer(0)), _
           DetailData, _
           Needed, _
           0)
        
        Call DisplayResultOfAPICall(" Result of second call: ")
        lstResults.AddItem "  MyDeviceInterfaceDetailData.cbSize: " & _
            CStr(MyDeviceInterfaceDetailData.cbSize)
        
        'Convert the byte array to a string.
        DevicePathName = CStr(DetailDataBuffer())
        'Convert to Unicode.
        DevicePathName = StrConv(DevicePathName, vbUnicode)
        'Strip cbSize (4 characters) from the beginning.
        DevicePathName = Right$(DevicePathName, Len(DevicePathName) - 4)
        'Strip 2 trailing nulls from the end.
        DevicePathName = Left$(DevicePathName, Len(DevicePathName) - 2)
        lstResults.AddItem "  Device pathname: " & DevicePathName
                
        '******************************************************************************
        'CreateFile
        'Returns: a handle that enables reading and writing to the device.
        'Requires:
        'The DevicePathName returned by SetupDiGetDeviceInterfaceDetail.
        '******************************************************************************
    
        HID = CreateFile _
            (DevicePathName, _
            GENERIC_READ Or GENERIC_WRITE, _
            (FILE_SHARE_READ Or FILE_SHARE_WRITE), _
            0, _
            OPEN_EXISTING, _
            0, _
            0)
            
        Call DisplayResultOfAPICall("CreateFile")
        lstResults.AddItem "  Returned handle: " & Hex$(HID) & "h"
        
        'Now we can find out if it's the device we're looking for.
        
        '******************************************************************************
        'HidD_GetAttributes
        'Requests information from the device.
        'Requires: The handle returned by CreateFile.
        'Returns: a HIDD_ATTRIBUTES structure containing
        'the Vendor ID, Product ID, and Product Version Number.
        'Use this information to determine if the detected device
        'is the one we're looking for.
        '******************************************************************************
        
        'Set the Size property to the number of bytes in the structure.
        DeviceAttributes.Size = LenB(DeviceAttributes)
        Result = HidD_GetAttributes _
            (HID, _
            DeviceAttributes)
            
        Call DisplayResultOfAPICall("HidD_GetAttributes")
        If Result <> 0 Then
            lstResults.AddItem "  HIDD_ATTRIBUTES structure filled without error."
        Else
            lstResults.AddItem "  Error in filling HIDD_ATTRIBUTES structure."
        End If
    
        lstResults.AddItem "  Structure size: " & DeviceAttributes.Size
        lstResults.AddItem "  Vendor ID: " & Hex$(DeviceAttributes.VendorID)
        lstResults.AddItem "  Product ID: " & Hex$(DeviceAttributes.ProductID)
        lstResults.AddItem "  Version Number: " & Hex$(DeviceAttributes.VersionNumber)
        
        'Find out if the device matches the one we're looking for.
        If (DeviceAttributes.VendorID = MyVendorID) And _
            (DeviceAttributes.ProductID = MyProductID) Then
                lstResults.AddItem "  My device detected"
                MyDeviceDetected = True
        Else
                MyDeviceDetected = False
                'If it's not the one we want, close its handle.
                Result = CloseHandle _
                    (HID)
                DisplayResultOfAPICall ("CloseHandle")
        End If
End If
    'Keep looking until we find the device or there are no more left to examine.
    MemberIndex = MemberIndex + 1
Loop Until (LastDevice = True) Or (MyDeviceDetected = True)

If MyDeviceDetected = True Then
    FindTheHid = True
    Call GetDeviceCapabilities
Else
    lstResults.AddItem " Device not found."
End If

End Function

Private Function GetDataString _
    (Address As Long, _
    Bytes As Long) _
As String

'Retrieves a string of length Bytes from memory, beginning at Address.
'Adapted from Dan Appleman's "Win32 API Puzzle Book"
Dim Offset As Integer
Dim Result$
Dim ThisByte As Byte

For Offset = 0 To Bytes - 1
    Call RtlMoveMemory(ByVal VarPtr(ThisByte), ByVal Address + Offset, 1)
    If (ThisByte And &HF0) = 0 Then
        Result$ = Result$ & "0"
    End If
    Result$ = Result$ & Hex$(ThisByte) & " "
Next Offset

GetDataString = Result$
End Function

Private Function GetErrorString _
    (ByVal LastError As Long) _
As String

'Returns the error message for the last error.
'Adapted from Dan Appleman's "Win32 API Puzzle Book"
Dim Bytes As Long
Dim ErrorString As String
ErrorString = String$(129, 0)
Bytes = FormatMessage _
    (FORMAT_MESSAGE_FROM_SYSTEM, _
    0&, _
    LastError, _
    0, _
    ErrorString$, _
    128, _
    0)
    
'Subtract two characters from the message to strip the CR and LF.
If Bytes > 2 Then
    GetErrorString = Left$(ErrorString, Bytes - 2)
End If
End Function

Private Sub cmdContinuous_Click()
'Enables the user to select 1-time or continuous data transfers.

If cmdContinuous.Caption = "Continuous" Then
    'Change the command button to Cancel Continuous
    cmdContinuous.Caption = "Cancel Continuous"
    'Enable the timer to send reports periodically.
    tmrContinuousDataCollect.Enabled = True
    Call GetOuputDataAndSendReport
Else
    'Change the command button to Continuous
    cmdContinuous.Caption = "Continuous"
    'Disable the timer that sends reports periodically.
    tmrContinuousDataCollect.Enabled = False
End If
End Sub

Private Sub cmdOnce_Click()
Call GetOuputDataAndSendReport
End Sub

Private Sub cmdRequestReports_Click()
'Start or stop reading reports from the device.

If cmdRequestReports.Caption = "Request Reports" Then
    'Change the command button's caption.
    cmdRequestReports.Caption = "Stop Requesting Reports"
    'Call the routine that instructs the server to read reports from the device.
    Call RequestReportsFromTheHID
Else
    'Change the command button's caption.
    cmdRequestReports.Caption = "Request Reports"
    'Tell the server to stop reading reports.
    Call StopReadingReports
End If
End Sub

Private Sub DisplayResultOfAPICall(FunctionName As String)
'Display the results of an API call.
Dim ErrorString As String
lstResults.AddItem ""
ErrorString = GetErrorString(Err.LastDllError)
lstResults.AddItem FunctionName
lstResults.AddItem "  Result = " & ErrorString
'Scroll to the bottom of the list box.
lstResults.ListIndex = lstResults.ListCount - 1
End Sub

Private Sub Form_Load()
frmMain.Show
Call Startup
End Sub

Private Sub Form_Unload(Cancel As Integer)
Call Shutdown
End Sub

Private Sub GetDeviceCapabilities()

'******************************************************************************
'HidD_GetPreparsedData
'Returns: a pointer to a buffer containing information about the device's capabilities.
'Requires: A handle returned by CreateFile.
'There's no need to access the buffer directly,
'but HidP_GetCaps and other API functions require a pointer to the buffer.
'******************************************************************************

Dim ppData(29) As Byte
Dim ppDataString As Variant

'Preparsed Data is a pointer to a routine-allocated buffer.
Result = HidD_GetPreparsedData _
    (HID, _
    PreparsedData)
Call DisplayResultOfAPICall("HidD_GetPreparsedData")

'Copy the data at PreparsedData into a byte array.
Result = RtlMoveMemory _
    (ppData(0), _
    PreparsedData, _
    30)
Call DisplayResultOfAPICall("RtlMoveMemory")

ppDataString = ppData()
'Convert the data to Unicode.
ppDataString = StrConv(ppDataString, vbUnicode)

'******************************************************************************
'HidP_GetCaps
'Find out the device's capabilities.
'For standard devices such as joysticks, you can find out the specific
'capabilities of the device.
'For a custom device, the software will probably know what the device is capable of,
'so this call only verifies the information.
'Requires: The pointer to a buffer containing the information.
'The pointer is returned by HidD_GetPreparsedData.
'Returns: a Capabilites structure containing the information.
'******************************************************************************
Result = HidP_GetCaps _
    (PreparsedData, _
    Capabilities)

Call DisplayResultOfAPICall("HidP_GetCaps")
lstResults.AddItem "  Last error: " & ErrorString
lstResults.AddItem "  Usage: " & Hex$(Capabilities.Usage)
lstResults.AddItem "  Usage Page: " & Hex$(Capabilities.UsagePage)
lstResults.AddItem "  Input Report Byte Length: " & Capabilities.InputReportByteLength
lstResults.AddItem "  Output Report Byte Length: " & Capabilities.OutputReportByteLength
lstResults.AddItem "  Feature Report Byte Length: " & Capabilities.FeatureReportByteLength
lstResults.AddItem "  Number of Link Collection Nodes: " & Capabilities.NumberLinkCollectionNodes
lstResults.AddItem "  Number of Input Button Caps: " & Capabilities.NumberInputButtonCaps
lstResults.AddItem "  Number of Input Value Caps: " & Capabilities.NumberInputValueCaps
lstResults.AddItem "  Number of Input Data Indices: " & Capabilities.NumberInputDataIndices
lstResults.AddItem "  Number of Output Button Caps: " & Capabilities.NumberOutputButtonCaps
lstResults.AddItem "  Number of Output Value Caps: " & Capabilities.NumberOutputValueCaps
lstResults.AddItem "  Number of Output Data Indices: " & Capabilities.NumberOutputDataIndices
lstResults.AddItem "  Number of Feature Button Caps: " & Capabilities.NumberFeatureButtonCaps
lstResults.AddItem "  Number of Feature Value Caps: " & Capabilities.NumberFeatureValueCaps
lstResults.AddItem "  Number of Feature Data Indices: " & Capabilities.NumberFeatureDataIndices

'******************************************************************************
'HidP_GetValueCaps
'Returns a buffer containing an array of HidP_ValueCaps structures.
'Each structure defines the capabilities of one value.
'This application doesn't use this data.
'******************************************************************************

'This is a guess. The byte array holds the structures.
Dim ValueCaps(1023) As Byte

Result = HidP_GetValueCaps _
    (HidP_Input, _
    ValueCaps(0), _
    Capabilities.NumberInputValueCaps, _
    PreparsedData)
   
Call DisplayResultOfAPICall("HidP_GetValueCaps")

'lstResults.AddItem "ValueCaps= " & GetDataString((VarPtr(ValueCaps(0))), 180)
'To use this data, copy the byte array into an array of structures.
End Sub

Private Sub RequestReportsFromTheHID()
'Request the ActiveX Exe server to attempt to read reports from the device.

Dim ApplicationProcessID As Long
Dim NumberOfBytesRead As Long
Dim UBoundReadBuffer As Integer

'Send an Output report with byte 0=0.
OutputReportData(0) = &H0
'The SendReportToTheHID routine also checks to be sure the device is present
'and if not, searches for it.
Call SendReportToTheHID
    
'If SendReport succeeded (DeviceDetected = True), tell the ActiveX Exe server to attempt
'to read reports from the device.
'When a report has been read, the server raises the ReportReady event
'in the application.
 
If DeviceDetected = True Then
    'The ReadBuffer array begins at 0, so subtract 1 from the number of bytes.
    If Capabilities.InputReportByteLength > 0 Then
        ReDim ReadBuffer(Capabilities.InputReportByteLength - 1)
    End If
    
    'Under Windows 2000, the server must obtain a duplicate handle to the device.
    '(Windows 98 can get the device handle either by obtaining a duplicate handle or
    'by using a passed device pathname to get a handle with CreateFile.)
    'This code uses a duplicate handle so it will work on both operating systems.
    
    'To enable the server to get a duplicate handle, the application must pass
    'its Process ID and device handle (HID).
    'The server uses these values to open the application process
    'and get its own handle for accessing the device.
    
    ApplicationProcessID = GetCurrentProcessId
    'Call the server routine.
    Call HIDObj.InitiateHIDReads _
        (ApplicationProcessID, _
        HID, _
        ReadBuffer(), _
        CLng(Capabilities.InputReportByteLength))
End If
End Sub

Private Sub HidObj_ReportReady()
'The server raises this event when it has received an Input report from the device
'and is ready to send the report to the application.
'The application then calls the server's ReturnReportData routine, which returns the
'report data in a callback.

'Optional message box for debugging.
'MsgBox "Report Ready"

'Me is this application. ReadBuffer() will contain the report data.
Call HIDObj.ReturnReportData _
        (Me, _
        ReadBuffer())

'Save the report number for display.
ReportNumber = ReportNumber + 1
End Sub

Private Sub InitializeDisplay()
Dim Count As Integer
Dim ByteValue As String
'Create a combo box to select the data byte in the Output Report.
For Count = 0 To 255
    If Len(Hex$(Count)) < 2 Then
        ByteValue = "0" & Hex$(Count)
    Else
        ByteValue = Hex$(Count)
    End If
    frmMain.cboByte1.AddItem ByteValue, Count
Next Count
'Select the default item for the box
frmMain.cboByte1.ListIndex = 128
'Check the checkbox
chkAutoincrement.Value = 1
'Report Header
lstResults.AddItem "HID Test Report"
End Sub

Public Sub InputReportData _
    (ReadSuccess As Boolean, _
    ReportParam() As Byte)
'This is the callback routine that the server calls when the application
'has requested a report.
Dim ByteValue As String
Dim Count As Integer

If ReadSuccess = True Then
    'Save the passed buffer.
    ReadBuffer() = ReportParam()
    
    'Display the report data in the list box.
    lstResults.AddItem " Report ID: " & ReadBuffer(0)
    lstResults.AddItem " Input Report Data:"
    
    'Display the report number and data.
    txtBytesReceived.Text = ""
    txtBytesReceived.SelStart = Len(txtBytesReceived.Text)
    txtBytesReceived.SelText = "Report #" & CStr(ReportNumber) & vbCrLf
    For Count = 1 To UBound(ReadBuffer)
        'Add a leading 0 to values 0 through Fh.
        If Len(Hex$(ReadBuffer(Count))) < 2 Then
            ByteValue = "0" & Hex$(ReadBuffer(Count))
        Else
            ByteValue = Hex$(ReadBuffer(Count))
        End If
        lstResults.AddItem " " & ByteValue
        'Display the received bytes in the text box.
        txtBytesReceived.SelStart = Len(txtBytesReceived.Text)
        txtBytesReceived.SelText = ByteValue & vbCrLf
    Next Count
Else
    lstResults.AddItem "Unable to read from device."
End If
'Scroll to the bottom of the list box.
lstResults.ListIndex = lstResults.ListCount - 1
End Sub

Private Sub SendReportToTheHID()
'Send a report to the device.

Dim Count As Integer
Dim NumberOfBytesRead As Long
Dim NumberOfBytesToSend As Long
Dim NumberOfBytesWritten As Long
Dim WriteSuccess As Boolean

'In most cases, once a device has been detected it will remain available.
'But it's possible that the device has been removed, or removed and reattached
'(with a new handle). We need to handle each of these cases.

If DeviceDetected = True Then
    WriteSuccess = DoAWriteFile
    'If the write attempt failed, it may be because the device was removed,
    'then reattached. So try to find it again.
    If WriteSuccess = False Then
        DeviceDetected = FindTheHid
        'If success, try to write to the device.
        If DeviceDetected = True Then
            WriteSuccess = DoAWriteFile
        End If
    End If
Else
    'If the device isn't detected, try to find it.
    DeviceDetected = FindTheHid
    'If success, try to write to it.
    If DeviceDetected = True Then
        WriteSuccess = DoAWriteFile
    End If
End If
    
If WriteSuccess = True Then
    lstResults.AddItem " OutputReportByteLength = " & Capabilities.OutputReportByteLength
    lstResults.AddItem " NumberOfBytesWritten = " & NumberOfBytesWritten
    lstResults.AddItem " Report ID: " & SendBuffer(0)
    lstResults.AddItem " Output Report Data:"
    For Count = 1 To UBound(SendBuffer)
        lstResults.AddItem " " & Hex$(SendBuffer(Count))
    Next Count
Else
    lstResults.AddItem "Unable to write to device."

End If
'Scroll to the bottom of the list box.
lstResults.ListIndex = lstResults.ListCount - 1
End Sub

Private Sub Shutdown()
'Includes actions that must execute when the program ends.

'Send a report to the device to tell the device to
'tell the server to stop reading from the device.
Call StopReadingReports

'Close the open handle to the device.
Result = CloseHandle _
    (HID)
Call DisplayResultOfAPICall("CloseHandle (HID)")

'Free memory used by SetupDiGetClassDevs
'Nonzero = success
Result = SetupDiDestroyDeviceInfoList _
    (DeviceInfoSet)
Call DisplayResultOfAPICall("DestroyDeviceInfoList")

Result = HidD_FreePreparsedData _
    (PreparsedData)
Call DisplayResultOfAPICall("HidD_FreePreparsedData")

End Sub

Private Sub Startup()
'The HIDServer object reads reports from the device.
Set HIDObj = CreateObject("HIDServer.clsHID")
Call InitializeDisplay
tmrContinuousDataCollect.Enabled = False
'When Continuous is selected, send reports at this interval:
tmrContinuousDataCollect.Interval = 1000
DeviceDetected = False
End Sub

Private Sub StopReadingReports()
'Send an Output report to the device with byte 0 = FFh.
'This tells the device to notify the server that it should stop
'reading from the device.
'When the device reads the report, it sets byte 0 of its next Input report to FFh.
'When the server reads this report, it knows that it should stop attempting to
'read Input reports from the device. This enables the server to close.
OutputReportData(0) = &HFF
Call SendReportToTheHID
End Sub

Private Sub tmrContinuousDataCollect_Timer()
'Send an Output report to the device.
Call GetOuputDataAndSendReport
End Sub

Private Sub GetOuputDataAndSendReport()
'Get the report data and send the report to the device

txtBytesReceived.SelText = vbCrLf
lstResults.AddItem Format(Now, "general date")

'Send byte 1 from the combo box.
'Byte 0 is for signaling and is set by the Request Reports button's click routine.
'Increment the value if the autoincrement check box is selected.

If chkAutoincrement.Value = 1 Then
    If cboByte1.ListIndex < 255 Then
        cboByte1.ListIndex = cboByte1.ListIndex + 1
    Else
        cboByte1.ListIndex = 0
    End If
End If

OutputReportData(1) = cboByte1.ListIndex

'Write a report to the device
Call SendReportToTheHID
End Sub
